﻿履歴マネージャー:
	Gui,4: New
	;=========================================== 機能設定画面を操作不可にする
	Gui,1:Hide
	;-------------------------------------- 既に設定画面を開いているときは何もしない
	IfWinExist 履歴マネージャー
	{
		Return
	}
	;=========================================== フォントの設定
	Gui,4: Font, s11, 
	;=========================================== 履歴マネージャー	
	Gui, Add, ListView, x22 y19 w770 h380 NoSortHdr Grid -Multi AltSubmit Checked vHistoryLV gOnActionHistoryLV, メニュー表示|クリップボードテキスト|タイムスタンプ|
	;--------------- クリップボード履歴を読み込んでリストビューを構築する
	Gosub BuildHistoryLV
	Gui, Add, Button, x52 y419 w40 h30 Disabled1 vHistoryUpBtn gHistoryUp, ↑
	Gui, Add, Button, x102 y419 w40 h30 Disabled1 vHistoryDownBtn gHistoryDown, ↓
	Gui, Add, Button, x162 y419 w90 h30 Disabled1 vHistoryDeleteBtn gHistoryDelete, 削除
	Gui, Add, Button, x572 y419 w90 h30 Disabled1 vHistorySaveBtn gOnClickHistorySaveBtn, 保存
	;=========================================== 保存後に再表示したとき
	IniRead,strWrk,%IniFileName%,AUTOEXEC,StartUp,0
	If (strWrk == 1) {
		;--------------- 再表示指定をクリアする
		IniWrite,0,%IniFileName%,AUTOEXEC,StartUp
		;--------------- 保存ボタンを押せないようにする
		GuiControl, Disabled1, HistorySaveBtn
	}
	Gui, Add, Button, x682 y419 w100 h30 gCloseHistoryManager, 閉じる
	;=========================================== 画面表示
	Gui, Show, h479 w816, 履歴マネージャー
Return
;=========================================== リストビューが選択されたときの処理
OnActionHistoryLV:
	;-------------------------------------- リストビューがフォーカスを受け取ったときは、処理対象のリストビューを変更する
	If (A_GuiEvent == "F" || A_GuiEvent == "Normal") {
		Gui, ListView, HistoryLV
	}
	;-------------------------------------- リストビューのチェックボックスがクリックされたときの処理
	If (A_GuiEvent == "I" && (InStr(ErrorLevel, "c") > 0 || InStr(ErrorLevel, "C") > 0)) {
		;-------------------------------------- 保存ボタンを押せるようにする
		GuiControl, Enable1, HistorySaveBtn
		;-------------------------------------- リストビューの選択状態が変化したときは、リストビューにフォーカスをあわせる（ここでフォーカスをあててないと次にリストビューの項目をクリックしたときに正しくイベントが受け取れないため）
		GuiControl, Focus, HistoryLV
	}
	;------------------------------ 選択されている行の行番号を取得する
	SelectedRow := LV_GetNext(0)
	;------------------------------ 項目が埋まっている行がクリックされたときだけ処理する
	If (A_GuiEvent == "Normal") {
		;------------------------------ 項目が埋まっている行がクリックされたときだけ処理する
		If (SelectedRow > 0) {
			;-------------------------------------- ボタンを押せるようにする
			Gosub EnableButton
		}Else{
			;-------------------------------------- ボタンを押せないようにする
			Gosub DisableButton
		}
	}
Return
;=========================================== ボタンを押せるようにする
EnableButton:
	GuiControl, Enable1, HistoryUpBtn
	GuiControl, Enable1, HistoryDownBtn
	GuiControl, Enable1, HistoryDeleteBtn
	;-------------------------------------- リストビューを操作可能に戻す
	;GuiControl, Enable1, HistoryLV
Return
;=========================================== ボタンを押せないようにする
DisableButton:
	GuiControl, Enable0, HistoryUpBtn
	GuiControl, Enable0, HistoryDownBtn
	GuiControl, Enable0, HistoryDeleteBtn
	;-------------------------------------- リストビューを操作可能に戻す
	;GuiControl, Enable1, HistoryLV
Return
;=========================================== ↑ボタンを押したときの処理
HistoryUp:
	;-------------------------------------- 選択されている行を上げる
	HistoryUpDown("Up")
Return
;=========================================== ↓ボタンを押したときの処理
HistoryDown:
	;-------------------------------------- 選択されている行を下げる
	HistoryUpDown("Down")
;=========================================== リストビューの項目を上下する
HistoryUpDown(UpDown) {
	;-------------------------------------- 選択されている行の番号を取得する
	SelectedRow := LV_GetNext(0)
	If (UpDown == "Up") {
		If (SelectedRow > 1) {
			AltRow := SelectedRow - 1
		}Else{
			AltRow := 0
		}
	}Else{
		If (SelectedRow < LV_GetCount()) {
			AltRow := SelectedRow + 1
		}Else{
			AltRow := 0
		}
	}
	If (AltRow > 0) {
		;-------------------------------------- リストビューから表示を取得し配列に保存する
		HistoryFixedMem := Object()
		HistoryMenuTextMem := Object()
		HistoryTextMem := Object()
		HistoryAddTimeMem := Object()
		LV_Count := LV_GetCount()
		Loop %LV_Count% {
			;-------------------------------------- リストビューのチェックボックスの状態を取得する
			ix := A_Index - 1
			If (LV_GetNext(ix, "C") == A_Index) {
				HistoryFixedMem[A_Index] := 1
			}Else{
				HistoryFixedMem[A_Index] := 0
			}
			LV_GetText(strWrk, A_Index, 1)
			HistoryMenuTextMem[A_Index] := strWrk
			LV_GetText(strWrk, A_Index, 2)
			HistoryTextMem[A_Index] := strWrk
			LV_GetText(strWrk, A_Index, 3)
			HistoryAddTimeMem[A_Index] := strWrk
		}
		;-------------------------------------- 順番を変更する
		Wrk := HistoryFixedMem[AltRow]
		HistoryFixedMem[AltRow] := HistoryFixedMem[SelectedRow]
		HistoryFixedMem[SelectedRow] := Wrk
		;-------------------------------------- 順番を変更する
		Wrk := HistoryMenuTextMem[AltRow]
		HistoryMenuTextMem[AltRow] := HistoryMenuTextMem[SelectedRow]
		HistoryMenuTextMem[SelectedRow] := Wrk
		;-------------------------------------- 順番を変更する
		Wrk := HistoryTextMem[AltRow]
		HistoryTextMem[AltRow] := HistoryTextMem[SelectedRow]
		HistoryTextMem[SelectedRow] := Wrk
		;-------------------------------------- 順番を変更する
		Wrk := HistoryAddTimeMem[AltRow]
		HistoryAddTimeMem[AltRow] := HistoryAddTimeMem[SelectedRow]
		HistoryAddTimeMem[SelectedRow] := Wrk
		;-------------------------------------- リストビューをいったん削除する
		LV_Delete()
		;-------------------------------------- リストビューを再構築する
		loop %LV_Count% {
			LV_Add("Check"HistoryFixedMem[A_Index], HistoryMenuTextMem[A_Index], HistoryTextMem[A_Index], HistoryAddTimeMem[A_Index])
		}
		;-------------------------------------- リストビューの列幅を調整する
		LV_ModifyCol(1,"AutoHdr")
		LV_ModifyCol(2,"AutoHdr")
		LV_ModifyCol(3,"AutoHdr")
		;-------------------------------------- 移動した項目を選択する
		LV_Modify(AltRow,"Select Vis")
		;-------------------------------------- 保存ボタンを押せるようにする
		GuiControl, Enable1, HistorySaveBtn
	}
}
Return
;=========================================== 削除ボタンを押したときの処理
HistoryDelete:
	;-------------------------------------- 選択されている行番号を保管する
	ix := LV_GetNext(0)
	;-------------------------------------- 選択されている行を削除する（DeleteSelectedRow関数は定型文画面のスクリプトで定義）
	Rs := DeleteSelectedRow()
	HistoryCtr -= 1
	;-------------------------------------- ボタンを制御する
	GuiControl, Enable1, HistorySaveBtn
	GuiControl, Enable0, HistoryUpBtn
	GuiControl, Enable0, HistoryDownBtn
	GuiControl, Enable0, HistoryDeleteBtn
Return
;=========================================== 保存ボタンを押したときの処理
OnClickHistorySaveBtn:
	;-------------------------------------- 元の設定をいったん削除する
	loop {
		;------------------------------------- 固定アイテムを削除する
		Section = FIXEDITEM%A_Index%
		IniRead,strWrk,%IniFileName%,%Section%,FixedClipMenuText,-1
		If (strWrk == -1) {
			Break
		}
		IniDelete,%IniFileName%,%Section%
	}
	loop {
		;------------------------------------- クリップボード履歴を削除する
		Section = HISTORY%A_Index%
		IniRead,strWrk,%IniFileName%,%Section%,ClipMenuText,-1
		If (strWrk == -1) {
			Break
		}
		IniDelete,%IniFileName%,%Section%
	}
	;-------------------------------------- リストビューを処理対象に変更する
	Gui,ListView,HistoryLV
	;-------------------------------------- カウンターを初期化する
	LV_Count := LV_GetCount()
	FixCtr := 0
	HisCtr := 0
	Loop %LV_Count% {
		;-------------------------------------- リストビューのチェックボックスの状態を取得して保存するiniファイルのセクション番号を設定する
		;--------------- チェックが入っているか確認する
		ix := A_Index - 1
		CheckedNo := LV_GetNext(ix, "C")
		If (CheckedNo == A_Index) {
			;------------------------------------- 固定アイテムを保存する
			FixCtr += 1
			Section = FIXEDITEM%FixCtr%
			;------------------------------------- 履歴メニュー表示テキスト
			LV_GetText(strWrk, A_Index, 1)
			IniWrite,%strWrk%,%IniFileName%,%Section%,FixedClipMenuText
			;------------------------------------- 履歴テキスト
			LV_GetText(strWrk, A_Index, 2)
			IniWrite,%strWrk%,%IniFileName%,%Section%,FixedClipText
			;------------------------------------- 登録時刻
			LV_GetText(strWrk, A_Index, 3)
			IniWrite,%strWrk%,%IniFileName%,%Section%,FixedCLipAddTime
		}Else{
			;------------------------------------- クリップボード履歴を保存する
			HisCtr += 1
			Section = HISTORY%HisCtr%
			;------------------------------------- 履歴メニュー表示テキスト
			LV_GetText(strWrk, A_Index, 1)
			IniWrite,%strWrk%,%IniFileName%,%Section%,ClipMenuText
			;------------------------------------- 履歴テキスト
			LV_GetText(strWrk, A_Index, 2)
			IniWrite,%strWrk%,%IniFileName%,%Section%,ClipText
			;------------------------------------- 登録時刻
			LV_GetText(strWrk, A_Index, 3)
			IniWrite,%strWrk%,%IniFileName%,%Section%,CLipAddTime
		}
	}
	;-------------------------------------- リロードして再表示したときにクリップボードの内容が履歴に保存されてしまうのを防ぐためクリップボードをクリアする
	clipboard = 
	;-------------------------------------- リロードして再表示する
	Gosub SaveLastSessionAndReloadHM
Return
;=========================================== クリップボード履歴を読み込んでリストビューを構築する
BuildHistoryLV:
	HistoryCtr := 0
	loop {
		;------------------------------------- 固定アイテムを読み込む
		Section = FIXEDITEM%A_Index%
		;------------------------------------- 履歴メニュー表示テキスト
		IniRead,FixedMenuText,%IniFileName%,%Section%,FixedClipMenuText,-1
		If (FixedMenuText == -1) {
			Break
		}
		;------------------------------------- 履歴テキスト
		IniRead,FixedText,%IniFileName%,%Section%,FixedClipText,-1	
		;------------------------------------- 保存日時
		IniRead,FixedAddTime,%IniFileName%,%Section%,FixedCLipAddTime,-1
		;------------------------------------- リストビューに追加する
		LV_Add("Check1", FixedMenuText, FixedText, FixedAddTime)
		HistoryCtr += 1
	}
	loop {
		;------------------------------------- クリップボード履歴を読み込む
		Section = HISTORY%A_Index%
		;------------------------------------- 履歴メニュー表示テキスト
		IniRead,HistoryMenuText,%IniFileName%,%Section%,ClipMenuText,-1
		If (HistoryMenuText == -1) {
			Break
		}
		;------------------------------------- 履歴テキスト
		IniRead,HistoryText,%IniFileName%,%Section%,ClipText,-1	
		;------------------------------------- 保存日時
		IniRead,HistoryAddTime,%IniFileName%,%Section%,CLipAddTime,-1
		;------------------------------------- リストビューに追加する
		LV_Add("Check0", HistoryMenuText, HistoryText, HistoryAddTime)
		HistoryCtr += 1
	}
	;------------------------------------- リストビューの列幅を調整する
	LV_ModifyCol(1,"AutoHdr")
Return
;=========================================== GUI画面を閉じたときの処理
CloseHistoryManager:
	Gui, Destroy
Return
;=========================================== リロードして再表示する
SaveLastSessionAndReloadHM:
	;-------------------------------------- リロード後、設定画面を再表示させるように設定する
	IniWrite,1,%IniFileName%,AUTOEXEC,StartUp
	IniWrite,履歴マネージャー,%IniFileName%,AUTOEXEC,ShowConfigPanel
	;-------------------------------------- リロードして設定を反映させる
	Reload
Return